//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef ICFILE_H
#define ICFILE_H
#include <vector>
#include <string>
#include "Exception.h"

class ICFile {
  string name;
  void *file;
  bool  wopen;

  vector<int> record_starts;
public:
  ICFile() : file(NULL) {};
  ICFile(const string &name) throw (Exception);
  ~ICFile();

  bool open(const string &name, bool write = false) throw (Exception);

  bool isWritable()       const { return wopen; };

  void   push_back(const string &data) throw (Exception);
  string read(int record)              throw (Exception);

  int    getNumRecords() const { return record_starts.size(); }
  string getFileName()   const { return name; }
private:
  void setupIndexList()  throw (Exception);
  int  readNoSeek(string &res);
};

#endif







