
//#define POS_RES_TRACE(output) Comm::sendMCmd(output)

//#define ATTACKTRACE
//#define FREEPOSTRACE
//#define COVERTRACE
//#define SUPPTRACE

//#define CERR(output) cerr << "POSM: "<<wS->time << "No. " <<me.number<<output<< endl


#ifndef POS_RES_TRACE
#define POS_RES_TRACE(output)
#else
#warning POS_RES_TRACE aktiviert!!
#define FUNSSELMACROS
#include "drawMacros.h"
#define USEPOS_RES_LOG
#endif

#ifndef USEPOS_RES_LOG
#define POS_RES_LOG(output)
#else
#warning POS_RES_LOG aktiviert !!
#define POS_RES_LOG(output) { ostrstream ost;\
	ost << "POS_RES_LOG: " << output << (char)0;\
	Comm::sendMCmd(MLog(ost.str()));}
#endif

#ifdef SUPPTRACE
#warning: POSM debug trace COVERTRACE is activated!
#define SUPPTRC(output) Comm::sendMCmd(output)
#else
#define SUPPTRC(output)
#endif

#ifdef COVERTRACE
#warning: POSM debug trace COVERTRACE is activated!
#define COVERTRC(output) Comm::sendMCmd(output)
#else
#define COVERTRC(output)
#endif

#ifdef ATTACKTRACE
#warning: POSM debug trace ATTACKTRACE is activated!
#define ATTACKTRC(output) Comm::sendMCmd(output)
#else
#define ATTACKTRC(output)
#endif

#ifdef FREEPOSTRACE
#warning: POSM debug trace FREEPOSTRACE is activated!
#define FREEPOSTRC(output) Comm::sendMCmd(output)
#else
#define FREEPOSTRC(output)
#endif

#ifndef CERR
#define CERR(output)
#else
#warning POSM CERR is aktivated
#endif

#include "PositionFunctions.h"
#include "PositionEval.h"


const double COVER_MIN_DIST=-FIELD_LENGTH*1/6.;
//opponents who are at this distance or less from our goal
//have to be covered 
const double KEEPOUT_X_FRONT = 2/3.;
const double KEEPOUT_X_BACK = 2/9. ;
const double KEEPOUT_Y = 1/8. ;

const double KEEPOUT_X_FRONT_BIG = 5/6. ;
const double KEEPOUT_X_BACK_BIG = 5/18.;
const double KEEPOUT_Y_BIG = 5/32.;

const double BIGGER_KEEPOUT_AREA = 0.3;
//this part of the Playerarea should be avoided when searching free position
//if the position is far away (which means longer than BIGGER_KEEPOUT_AREA*WidthOfPlayerarea) we check a bigger area
//continuous change of size
const double FAR_AWAY = FIELD_WIDTH/4. ;
const double NOT_ACTIVE_TOO_LONG = 5;
const double NEW_GRADE_FACTOR=1;
const double OLD_GRADE_FACTOR=1;
void
PositionModule::playerAttack(int OpponentNo) {

  if (OpponentNo == UNKNOWN) {
    CERR ("act -> attack failed, because OpponentNo is not set !");
    skills->noAction();
    return;
  }
  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! TODO
  //- player intercept (simBall) out of field?!?
  //- uses too much stamina?

  const double distToOpponent = 3 * PLAYER_SIZE; 
  // distance to keep when going around opponent in close range

  AdvSkills::TurtleCommand   turtleParams;  
  WorldPlayer opponent = wS->otherTeam(OpponentNo);
  WorldPlayer closestFriend;
  
  // is there a closest friend? ("close" means in opponent's kickrange)
  bool closestFriendExists = false;
  if (wS->my.number == tS->firstResponsiblePlayer) {
    if (tS->secondResponsiblePlayer != UNKNOWN) {
      closestFriend = wS->ourTeam(tS->secondResponsiblePlayer);
      closestFriendExists = ( closestFriend.distTo( opponent.pos ) 
			      < opponent.kickRange() );
    } 
  } else if (tS->firstResponsiblePlayer != UNKNOWN ) {
    closestFriend = wS->ourTeam(tS->firstResponsiblePlayer);
    closestFriendExists = ( closestFriend.distTo( opponent.pos ) 
			    < opponent.kickRange() );
  }

  // ball is not kickable right now (otherwise we wouldnt attack, but dribble)

  int       simTime = 0;      // time opponent will need to reach the ball
  WorldBall simBall = wS->ball;   // ball where opponent will reach it
  double    stam    = availableStamina;
  
  simBall = tS->otherTeamReachBallPos( tS->firstDangerousOpponent );
  simTime = tS->otherTeamReachBallTime( tS->firstDangerousOpponent );
  if (wS->otherTeam(tS->firstDangerousOpponent).age>1)
    {
      //as long as our information about the opponent is too old
      //we assume he has been going for the ball
      simTime-=1;
      ATTACKTRC(MLog("attack-> age of fDO is not 1, decreasing simTime!!"));
    };

#ifdef ATTACKTRACE
  ostrstream tmp;
  ATTACKTRC(CIRCLE(simBall.pos,BALL_SIZE));
  ATTACKTRC(CIRCLE(wS->ball.pos,skills->kickRange));
  tmp <<"attack-> attacking player no. : "<< OpponentNo<< char(0);
  ATTACKTRC(MLog(tmp.str()));
  ostrstream tmp1;
  tmp1 <<"attack-> other team reach ball time : "<< simTime << char(0);
  ATTACKTRC(MLog(tmp1.str()));
#endif

  AdvSkills::TurtleCommand goToParams = 
    skills->goToPositionTimed( wS, simBall.pos, stam, skills->kickRange );

  if( simTime == 0 )  // i.e. ball is in opponent's kickrange
    {
      // if opponent is not in my way, try to intercept directly
      // !! abwehrspieler sollten sich nicht komplett um den Spieler ziehen 
      // lassen

      if( goToParams.time <= 1 &&
	  wS->my.distTo(simBall.pos) < wS->my.distTo(opponent)) {
	skills->exec( wS, goToParams );
	ATTACKTRC(MLog("attack-> going directiy to ball, exec"));
	return;
      }
    }

  if ( (closestFriendExists) &&
       (tS->myTacticalNo < tS->ourTeamTacticalNo(closestFriend.number)) ) 
    {//Bedingung kapier ich nicht, kleinere Nummern sind doch defensiver?!?

      // I am second attacker:
      
      // if first attacker is between opponent and ball, block opponent
      if( closestFriend.inCorridor( opponent.pos, wS->ball.pos, 
				    skills->kickRange ) )
	{
	  goToParams = skills->goToPositionTimed( wS, opponent.pos, 
						  stam, 2 * PLAYER_SIZE );
	  skills->exec( wS, goToParams );
	  return;
	}
      
      // else try to directly intercept ball
      ATTACKTRC(MLog("attack -> second attacker; intercepting ball"));
      goToParams=skills->goToPositionTimed(wS, simBall.pos, 
					   wS->senseBody.stamina, PLAYER_SIZE);
      //goToParams = goAroundOpponent(simBall.pos, opponent, distToOpponent, 
      //			    wS->senseBody.stamina);
      ATTACKTRC( POSITION ( simBall.pos ) );      
    }
  else {
    
    // I am first attacker:
    Vector2d target;

    // if I am between opponent and ball, just intercept
    if( wS->my.inCorridor( opponent.pos, wS->ball.pos, skills->kickRange ) )
      {
	ATTACKTRC(MLog("attack -> between ball and opp., intercepting ball"));
	turtleParams = skills->controlBall( wS, stam );
	skills->exec( wS, turtleParams );
	return;
      }
    if (fabs((me.pos-opponent.pos).getAngle())<M_PI/3.)
      { //ich wei nicht ob hier nicht statt simBall opponent besser wre, 
	//ich habe das mal so gehabt und dann spter gendert
	const double mindist=6*PLAYER_SIZE;
	ATTACKTRC(MLog("attack->opponent too far behind, going back"));

	if (!((fabs(opponent.pos.getX())+mindist<me.pos.getX()) && 
	      (fabs(opponent.pos.getX())-mindist>me.pos.getX())))
	  {
	    target.setY(me.pos.getY());
	    ATTACKTRC(MLog("attack-> going straight back"));
	  }
	else 
	  {
	    target.setY(opponent.pos.getY()<0?opponent.pos.getY()
			+mindist:opponent.pos.getY()-mindist);
	    ATTACKTRC(MLog("attack-> trying to get between center and opponent"));
	  };
	target.setX(opponent.pos.getX()-mindist);
	//hier auch simBall oder opponent
	ATTACKTRC(LINE(me.pos,target));
      }
    else
      if ((simBall.pos.getX() > 0) &&
	  (!tS->ourTeamDefender(me.number))) 
	   //d.h. ball ist in gegn. Hlfte
	{ 
	  // it's likely the ball is kicked, so attack ball directly
	  target = simBall.pos;
	}
      else 
      { //ball in unserer Hlfte
	// goto the position where the opponent is trying to
	// intercept ball, but stay on the side of our goal
	if (((wS->ball.pos-opponent.pos).getLength()<skills->kickRange*1.1) ||
	    ((simTime==0) && (opponent.age==1)))
	  {
	    ATTACKTRC(MLog("attack-> opponent in kickrange, intercepting opp."
			   ));
	    target=opponent.pos;
	  }
	else target=simBall.pos;

	turtleParams   = 
	  skills->goToPositionTimed(wS, target, 
				    wS->senseBody.stamina, PLAYER_SIZE);
	int reachtime=turtleParams.time;

#ifdef ATTACKTRACE
	ostrstream  tmp;
	tmp  << "attack-> trying to intercept player, time needed to "<<
	  "get to opp. interc. ball point: "<< 
	  reachtime<< char(0);
	ATTACKTRC(MLog(tmp.str()));
#endif

	Vector2d InterceptDir=(Vector2d(-0.5*FIELD_LENGTH,0)- simBall.pos);
	InterceptDir=1/InterceptDir.getLength()*InterceptDir;
	double tmp1=Step(-.5*FIELD_LENGTH+PENALTY_AREA_LENGTH+5,
			 -.5*FIELD_LENGTH+PENALTY_AREA_LENGTH+15,
			 simBall.pos.getX());

	InterceptDir=(tmp1*InterceptDir+(1-tmp1)*Vector2d(-1,0));
	InterceptDir=1/InterceptDir.getLength()*InterceptDir;
	//pretend that the opponent will go straight to our goal if he is
	//next to our penalty area, otherwise pretend he will go straight back

	if ((simTime<3) && 
	    ((goalShotEval->otherEval(wS,target)
	      ).is_better_than(Grade::AVERAGE)))
	{//immediate danger, the opponent will propably shoot into our goal, so
	  // forget everything and try to get between opponent and goal.
	  InterceptDir*=skills->kickRange+PLAYER_SIZE;
	  stam=wS->senseBody.stamina;
	  ATTACKTRC(MLog("attack-> opponent will propably shoot into our goal!!"));
	}
	else
	{
	  const double OppMaxSpeed=0.9;
	  Vector2d Me2Opp=1/PLAYER_SPEED_MAX*(target-me.pos);
	  
	  tmp1=(-simTime+InterceptDir*Me2Opp*OppMaxSpeed)/
	    (1-OppMaxSpeed*OppMaxSpeed);
	  double tmp2=(-sqrnorm(Me2Opp)+simTime*simTime)/
	    (1-OppMaxSpeed*OppMaxSpeed);
	  if (tmp1*tmp1<tmp2) 
	    {
	      ATTACKTRC(MLog("attack-> oh shit !! negativ value"));
	      CERR("Wurzel negativ!!!");
	      target=simBall.pos;
	      target.setY(me.pos.getY()+10);
	    }
	  else 
	    {//calculation of player intercepttime seems to be ok
#ifdef ATTACKTRACE
	      ostrstream temp1;
	      temp1 <<"attack->  c^2: "<< sqrnorm(Me2Opp)<< "tmp1: "
		    << tmp1<< " tmp2 : " <<tmp2 <<" b*C"<< InterceptDir*Me2Opp
		    <<char(0);
	      ATTACKTRC(MLog(temp1.str()));
#endif
	      tmp1+=sqrt((tmp1*tmp1)-tmp2);
	    
	      turtleParams   = 
		skills->goToPositionTimed(wS,tS->ourTeamReachBallPos(me.number), 
					  stam, PLAYER_SIZE);
	      
	      if ((turtleParams.time<simTime-1) || (reachtime<simTime-1))
		//if we can reach the ball before opponent, try to do it
		{
		  ATTACKTRC(MLog("attack->turtleParams.time<simTime!Ballhandling?"));
		  if (turtleParams.time<reachtime)
		    {
		      ATTACKTRC(MLog("attack->going to ourTeam reachBallpos"));
		      ATTACKTRC(LINE(me.pos,tS->ourTeamReachBallPos(me.number)));
		      ATTACKTRC(POSITION(tS->ourTeamReachBallPos(me.number)));
		      skills->exec(wS,turtleParams);
		      return;
		    }
		  else
		    {
		      InterceptDir=Vector2d(0,0);
		      turtleParams =
			skills->goToPositionTimed(wS,simBall.pos, 
						  stam, PLAYER_SIZE);
		      skills->exec(wS,turtleParams);
		      return;
		    };		
		}
	      else
		{
		  if (tmp1<0)
		    {
		      ATTACKTRC(MLog("attack -> tmp1 negativ doing safty hack"));
		      CERR("Mist! negativer Wert. das sollte nichtmehr vorkommen");
		      tmp1=fabs(tmp1);
		    }
		};
		    
#ifdef ATTACKTRACE
	      ostrstream temp;
	      temp <<"attack-> time to intercept after opp. got ball: "
		   << tmp1<< char(0);
	      ATTACKTRC(MLog(temp.str()));
#endif	  
	      
	    }; // if tmp1*tmp1<tmp2 else	  
	
	  InterceptDir*=.5*skills->kickRange+tmp1*OppMaxSpeed*PLAYER_SPEED_MAX;
	};	  
	ATTACKTRC(LINE(target,target+InterceptDir));
	target=target+InterceptDir;
      } // else..  ball in our half 
    ATTACKTRC(POSITION(target));
    target=goAroundOpponent(target,opponent,distToOpponent,1);
    goToParams   = skills->goToPositionTimed(wS, target,stam,
					     1.5*PLAYER_SIZE);
#ifdef ATTACKTRACE
    {
      ostrstream tmp;
      tmp << "attack-> used Stamina: " << stam<< char(0);
      ATTACKTRC(MLog(tmp.str()));
    };
#endif

    //    goToParams = goAroundOpponent(target, opponent, distToOpponent, 
    //				  wS->senseBody.stamina);
    // ist das nicht zuviel stamina?!?
    ATTACKTRC(MLog("attack -> first attacker; calculatet goAroundOpponent"));
  } //else (first attacker)
 
  // goToParams from one of the goAroundOpponent() above
  if( goToParams.state == AdvSkills::TFINISHED )
    {
      ATTACKTRC(MLog("attack -> reached target, intercepting ball"));
      goToParams = skills->goToPositionTimed( wS, wS->ball.pos, stam, 
					      skills->kickRange );
      if( goToParams.state == AdvSkills::TFINISHED )
	{
	  ATTACKTRC(MLog("attack -> ??? already reached ball ???"));
	  skills->noAction();
	  return;
	}
      skills->exec( wS, goToParams );
      return;
    }
  
  ATTACKTRC(MLog("attack -> exec skills"));
  skills->exec( wS, goToParams );
  return;
}


Vector2d 
PositionModule::goAroundOpponent(Vector2d target,
				     WorldPlayer opponent,
				     double dist,int inside) {
  //inside decides if a player decides wether a player tries to go 
  //around the opponent on the outside or on the inside of the field
  //normaly it should be (me.pos-target).getX(), but for attacking 
  //opponents, it is better to always go on the inside (the side facing
  //to our goal). Inside has to be positive in this case.

  Vector2d newTarget;
  double mindist=(opponent.pos-me.pos).getLength();
  mindist=mindist<4*PLAYER_SIZE?mindist:4*PLAYER_SIZE;

  ATTACKTRC(MLog("Attack-> goAroundOpponent"));

  //nchst Annherung an den Gegner, wenn ich geradeaus laufe
  Vector2d Odist=(target-me.pos);
  Odist=(me.pos+(1/(Odist.getLength()*Odist.getLength())*
		 Odist*(opponent.pos-me.pos))*Odist)-opponent.pos;

  //wenn die kleiner ist als mindist 
  //und der Gegner zwischen mir und meinem Ziel ist mu ich was tun!
  if ((Odist.getLength()<mindist) && 
      ((me.pos-target).getLength()>(me.pos-opponent.pos).getLength()) && 
      ((Odist+opponent.pos-target).getLength()
       <(me.pos-target).getLength()))
    {
      ATTACKTRC(MLog("Attack-> goAroundOpponent: in critical distance"));
      ATTACKTRC(LINE(target,me.pos));
      ATTACKTRC(LINE(opponent.pos,opponent.pos+Odist));
      
      //je nach der Variablen inside auf der inneren Seite vorbeilaufen,
      //oder auen
      Odist=target-me.pos;
      Odist*=1/Odist.getLength();
      Odist=mindist*Odist.perp();
      if (inside*Odist*(me.pos-Vector2d(-FIELD_LENGTH/2.0,0))<0)
	newTarget=opponent.pos+Odist;
      else newTarget=opponent.pos-Odist;

      Odist=newTarget-me.pos;
      Odist=1/Odist.getLength()*Odist;
      newTarget=newTarget+4*Odist;
      ATTACKTRC(LINE(me.pos,newTarget));
      ATTACKTRC(POSITION(newTarget));
    }
  else newTarget=target;
  return newTarget; 
}

double PositionModule::GradeToDouble(Grade value) 
{
  if (value.is_like(Grade::PERFECT))
    return 5 ;
  if (value.is_like(Grade::GOOD))
    return 4 ;
  if (value.is_like(Grade::AVERAGE))
    return 3 ;
  if (value.is_like(Grade::POOR))
    return 2 ;
  if (value.is_like(Grade::BAD))
    return 1 ;
  if (value.is_like(Grade::IMPOSSIBLE))
    return 0 ;
  return 0; 
}

Grade PositionModule::DoubleToGrade(double value)
{
  if ((0<=value)&&(value<0.5))
    return Grade::IMPOSSIBLE;
  if ((0.5<=value)&&(value<1.5))
    return Grade::BAD;
  if ((1.5<=value)&&(value<2.5))
    return Grade::POOR;
  if ((2.5<=value)&&(value<3.5))
    return Grade::AVERAGE;
  if ((3.5<=value)&&(value<4.5))
    return Grade::GOOD;
  if ((4.5<=value)&&(value<6))
    return Grade::PERFECT;
  return Grade::IMPOSSIBLE; 
}

Vector2d PositionModule::gotoFreePos()
{
    Snapshot testwS;
    WorldPlayer testme;
    int i,j,k,BestGradeNumber=0;
    Grade BestGrade;
    Vector2d checkPositions[NumberofPointsX*NumberofPointsY+1] ;
    Grade checkGrades[NumberofPointsX*NumberofPointsY+1] ;
    Grade middleGrades[NumberofPointsX*NumberofPointsY+1];
    Vector2d checkBestPosofPlayer[NumberofPointsX*NumberofPointsY+1] ;
    Vector2d middlePositionsCutOff[NumberofPointsX*NumberofPointsY+1] ;
    Vector2d min,max;
    double middleX, middleY;
    bool playerNear[NumberofPointsX*NumberofPointsY+1];
    int mindistNumber;
    double xFront, xBack, yFrontBack;
    positionEval->GetPlayerArea(me.number,min,max);
    FREEPOSTRC(BOX(min,max));
    //Where is best position to receive pass?
    //First check real position of player.
    checkPositions[0] = me.pos ;
    checkGrades[0] = passEval->ourEval(wS, tS->firstResponsiblePlayer,
				      me.number, checkBestPosofPlayer[0]);
    testme = me;
    testwS=*wS;
    //Where is best position for pass if player changes his position in the playerArea.
    //Divide PlayerArea into NumberofPointsX*NumberofPointsY  pieces and check the middle point of each piece:
    //     I   I
    //  -----------
    //     I   I 
    //  -----------
    //     I   I
   
    playerNear[0]=false ; //even if there's a player near your own position you should stay there if there's no better position
    //now check other positions in playerarea
    for (i=0;i<NumberofPointsX;i++)
    for (j=0;j<NumberofPointsY;j++)
      {
        //change PlayerPosition
        middleX=min.getX()+i*(max.getX()-min.getX())/NumberofPointsX+(max.getX()-min.getX())/(NumberofPointsX*2.);
        middleY=min.getY()+j*(max.getY()-min.getY())/NumberofPointsY+(max.getY()-min.getY())/(NumberofPointsY*2.);
	checkPositions[i*NumberofPointsY+j+1].setX(middleX);
	checkPositions[i*NumberofPointsY+j+1].setY(middleY);
	testme.pos=checkPositions[i*NumberofPointsY+j+1];			  
	testwS.setOurTeam(me.number,testme);
        //evaluate new Position
	checkGrades[i*NumberofPointsY+j+1] = 
	  passEval->ourEval(&testwS, tS->firstResponsiblePlayer,
			    me.number, checkBestPosofPlayer[i*NumberofPointsY+j+1]);
      }
       
    //if FreePos has not been active for a longer time start new calculation of middle points
    if(wS->time- lastActive > NOT_ACTIVE_TOO_LONG)
      {
        for (i=0;i<(NumberofPointsX*NumberofPointsY+1); i++)
          {
            middleGrades[i].set_IMPOSSIBLE() ;
	    sizeOfMiddleGrades[i]=0;
	    middlePositions[i].setXY(1000,1000);
          }
      } 
    for (i=0; i<(NumberofPointsX*NumberofPointsY+1); i++)
      {
        //calculate middlePositions
        if (middlePositions[i].getX()==1000) //start new calculation 
          middlePositions[i]= checkBestPosofPlayer[i];
        else
          middlePositions[i]= (middlePositions[i]*sizeOfMiddleGrades[i]+checkBestPosofPlayer[i]*GradeToDouble(checkGrades[i]))*
          (1/(sizeOfMiddleGrades[i]+GradeToDouble(checkGrades[i])));
	if(sizeOfMiddleGrades[i]==0)
	  {
	    middleGrades[i] = checkGrades[i];
            sizeOfMiddleGrades[i]=GradeToDouble(checkGrades[i]);
	  }
        else
          {
            sizeOfMiddleGrades[i] =  (OLD_GRADE_FACTOR*sizeOfMiddleGrades[i]+NEW_GRADE_FACTOR*GradeToDouble(checkGrades[i]))
	      /(OLD_GRADE_FACTOR+NEW_GRADE_FACTOR);
            middleGrades[i] = DoubleToGrade(sizeOfMiddleGrades[i]) ;
	  }
#ifdef FREEPOSTRACE
	{
	  int t(0),x(0),y(0);		  
	  for (t=0; t<NumberofPointsX; t++)
	    if((NumberofPointsY*t<i)&&(i<(t+1)*NumberofPointsY+1))
	      x=t ;
	  y=i-(x*NumberofPointsY)-1;
	  ostrstream tmp;
	  tmp << "gotoFreePos -> Position (" << x << ", " << y << ")  middleGrade " << middleGrades[i] <<"checkGrade" <<checkGrades[i] << char(0) ;
	  FREEPOSTRC(MLog(tmp.str()));
	  ostrstream tmp2;
	  tmp2 <<  "gotoFreePos -> Position (" << x << ", " << y << ")  SizeofMiddleGrade " << sizeOfMiddleGrades[i] <<char(0);
	  FREEPOSTRC(MLog(tmp2.str()));
	 
	}
#endif
        //cut off positions which are outside playerarea
        middlePositionsCutOff[i] = middlePositions[i] ;
        if (middlePositionsCutOff[i].getX() >max.getX())
          middlePositionsCutOff[i].setX(max.getX()) ;
	if (middlePositionsCutOff[i].getX() <min.getX())
          middlePositionsCutOff[i].setX(min.getX());
	if (middlePositionsCutOff[i].getY() >max.getY())
          middlePositionsCutOff[i].setY(max.getY()) ;
	if (middlePositionsCutOff[i].getY() <min.getY())
          middlePositionsCutOff[i].setY(min.getY()) ;
        //is one of our players near the middlePosition?
        playerNear[i]=false ;
	for (k=1;k<12;k++)
          if ((k != me.number)&&(k != tS->firstResponsiblePlayer))
            {
	      //if the player chooses a position far away from his own he checks a bigger area for other players
	      if (dist(me.pos, middlePositionsCutOff[i])>BIGGER_KEEPOUT_AREA*(max.getY()-min.getY()))
		//now the player is very far away	
		{  
		  xFront=KEEPOUT_X_FRONT_BIG;
		  xBack=KEEPOUT_X_BACK_BIG;
		  yFrontBack=KEEPOUT_Y_BIG;
		}
	      else
		//now we change the size of the keepoutarea continuously
		{
		  xFront=KEEPOUT_X_FRONT+dist(me.pos,middlePositionsCutOff[i])/(BIGGER_KEEPOUT_AREA*(max.getY()-min.getY()))*
		            (KEEPOUT_X_FRONT_BIG-KEEPOUT_X_FRONT);
		  xBack=KEEPOUT_X_BACK+dist(me.pos,middlePositionsCutOff[i])/(BIGGER_KEEPOUT_AREA*(max.getY()-min.getY()))*
			    (KEEPOUT_X_BACK_BIG-KEEPOUT_X_BACK);
		  yFrontBack=KEEPOUT_Y+dist(me.pos,middlePositionsCutOff[i])/(BIGGER_KEEPOUT_AREA*(max.getY()-min.getY()))*
		            (KEEPOUT_Y_BIG-KEEPOUT_Y);
		}
              if((wS->ourTeam(k).pos.getX()<middlePositionsCutOff[i].getX()+xFront*(max.getX()-min.getX()))&&
                 (wS->ourTeam(k).pos.getX()>middlePositionsCutOff[i].getX()-xBack*(max.getX()-min.getX()))&&
                 (wS->ourTeam(k).pos.getY()<middlePositionsCutOff[i].getY()+yFrontBack*(max.getY()-min.getY()))&&
                 (wS->ourTeam(k).pos.getY()>middlePositionsCutOff[i].getY()-yFrontBack*(max.getY()-min.getY()))&&
                 (wS->ourTeam(k).age <MAXAGE))
		{
		  playerNear[i]=true;
                  //just for the traces
                  Vector2d KeepoutMax;
		  KeepoutMax.setX(middlePositionsCutOff[i].getX()+xFront*(max.getX()-min.getX()));
		  KeepoutMax.setY(middlePositionsCutOff[i].getY()+yFrontBack*(max.getY()-min.getY()));
		  Vector2d KeepoutMin;
                  KeepoutMin.setX(middlePositionsCutOff[i].getX()-xBack*(max.getX()-min.getX()));
		  KeepoutMin.setY(middlePositionsCutOff[i].getY()-yFrontBack*(max.getY()-min.getY()));
                  FREEPOSTRC(SBOX(KeepoutMin,KeepoutMax,MDot));

#ifdef FREEPOSTRACE
    {
      int t(0),x(0),y(0);		  
      ostrstream tmp;
      for (t=0; t<NumberofPointsX; t++)
        if((NumberofPointsY*t<i)&&(i<(t+1)*NumberofPointsY+1))
	  x=t ;
      y=i-(x*NumberofPointsY)-1;
      tmp << "gotoFreePos -> Player_Near Position (" <<  x  << "," << y <<")   Player " << k <<char(0);
      FREEPOSTRC(MLog(tmp.str()));
    }
#endif

		}
	    }
      }

    //Downgrade positions too far away
    for (i=0; i<(NumberofPointsX*NumberofPointsY+1); i++)
      if (dist(middlePositionsCutOff[i], me.pos)> FAR_AWAY)
       {      
        middleGrades[i].downgrade();

#ifdef FREEPOSTRACE
    {
     int t(0),x(0),y(0);		  
     ostrstream tmp;
     for (t=0; t<NumberofPointsX; t++)
       if((NumberofPointsY*t<i)&&(i<(t+1)*NumberofPointsY+1))
	 x=t ;
     y=i-(x*NumberofPointsY)-1;
     tmp << "gotoFreePos ->  Position ( " << x  << ", " << y << ")  downgraded" << char(0);
     FREEPOSTRC(MLog(tmp.str()));
    }
#endif 
       }
    

    BestGrade.set_IMPOSSIBLE();
    //Which position has best grade?
    mindistNumber=0;
    for(i=0;i<(NumberofPointsX*NumberofPointsY+1);i++)
      {  
	if ((BestGrade.is_worse_than(middleGrades[i]))&&(playerNear[i]==false)) 
	{
	  BestGradeNumber=i;
	  BestGrade=middleGrades[i];
	}
        else 
          //if two positions have the same grade take the nearest to real position
	  if  (BestGrade.is_like(middleGrades[i])) 
	    if  ((dist(me.pos,middlePositionsCutOff[i]) < dist(me.pos,middlePositionsCutOff[BestGradeNumber]))&&(playerNear[i]==false))
	      BestGradeNumber=i;      
	if ((dist(middlePositionsCutOff[i],LastBestPos)<dist(middlePositionsCutOff[mindistNumber],LastBestPos))&&(playerNear[i]==false))
	  mindistNumber=i;
      } 
  FREEPOSTRC(POSITION(middlePositionsCutOff[BestGradeNumber]));
#ifdef FREEPOSTRACE
 { 
   int t(0),x(0),y(0);		  
   ostrstream tmp;
   for (t=0; t<NumberofPointsX; t++)
     if((NumberofPointsY*t<BestGradeNumber)&&(BestGradeNumber<(t+1)*NumberofPointsY+1))
       x=t ;
   y=BestGradeNumber-(x*NumberofPointsY)-1;
   tmp << "gotoFreePos -> BestGrade  Position ( " << x  << ", " << y << ")  Grade" << BestGrade << char(0);
   FREEPOSTRC(MLog(tmp.str()));
 }
#endif
  

  BestGrade.downgrade();
  //return the best position
  if (middleGrades[BestGradeNumber].is_better_than(Grade::POOR))
    if((BestGrade.is_better_than(middleGrades[mindistNumber]))||(LastBestPos.getX()==1000))
      {
	FREEPOSTRC(LINE(me.pos,middlePositionsCutOff[BestGradeNumber]));
	FREEPOSTRC(CIRCLE(middlePositionsCutOff[BestGradeNumber],3));
	FREEPOSTRC(MLog("free. pos-> going to position of best grade number"));
	// if we attack the offensive players should move forwards not backwards
        if((tS->ourTeamOffender(me.number))
	   &&(middlePositionsCutOff[BestGradeNumber].getX()<wS->ourTeam(tS->firstResponsiblePlayer).pos.getX()-10 )
	   &&(wS->ourTeam(tS->firstResponsiblePlayer).pos.getX()<(FIELD_LENGTH/2-3/4*PENALTY_AREA_LENGTH)) )
	      middlePositionsCutOff[BestGradeNumber].setX(max.getX());
	LastBestPos=middlePositionsCutOff[BestGradeNumber];
	if (dist(me.pos, middlePositionsCutOff[BestGradeNumber])>BIGGER_KEEPOUT_AREA*(max.getY()-min.getY()))
	  lookPos=middlePositionsCutOff[BestGradeNumber];
	return middlePositionsCutOff[BestGradeNumber];
      }
    else
      {
	FREEPOSTRC(LINE(me.pos,middlePositionsCutOff[mindistNumber]));
	FREEPOSTRC(CIRCLE(middlePositionsCutOff[mindistNumber],3));
	FREEPOSTRC(MLog("free. pos-> going to position of mindist number"));
	// if we attack the offensive players should move forwards not backwards
        if((tS->ourTeamOffender(me.number))
	   &&(middlePositionsCutOff[mindistNumber].getX()<wS->ourTeam(tS->firstResponsiblePlayer).pos.getX()-10 )
	   &&(wS->ourTeam(tS->firstResponsiblePlayer).pos.getX()<(FIELD_LENGTH/2-3/4*PENALTY_AREA_LENGTH)) )
	      middlePositionsCutOff[mindistNumber].setX(max.getX());
	LastBestPos=middlePositionsCutOff[mindistNumber];
	if (dist(me.pos, middlePositionsCutOff[mindistNumber])>BIGGER_KEEPOUT_AREA*(max.getY()-min.getY()))	
	  lookPos=middlePositionsCutOff[mindistNumber];
	return middlePositionsCutOff[mindistNumber];
      }
  else 
    {
      LastBestPos.setX(1000);
      LastBestPos.setY(1000);
      FREEPOSTRC(MLog("free. pos-> going to standard pos, best pass too bad"));
      return posGoal;
    };
  

};


void PositionModule::coverOpponent()
{
  Vector2d Opponents[5];
  int Numbers[5];
  Vector2d opp;
  int oppNumber;
  Vector2d temp;
  int tempNumber;
  int i;
  int j;

  for (i=0;i<5;i++)
    {
      Opponents[i]=Vector2d(0,0);
      Numbers[i]=UNKNOWN;
    }

  //find 5 Opponents who are closest to our goal
  for (i=1;i<12;i++)
    if(wS->otherTeam(i).age < MAXAGE)
      {
	opp=wS->otherTeam(i).pos;
	oppNumber=i;
	for (j=0;j<5;j++)
	  if ( 
	      (opp.getX()<Opponents[j].getX()) &&(opp.getX()<COVER_MIN_DIST))
	    {
	      temp=Opponents[j];
	      Opponents[j]=opp;
	      tempNumber=Numbers[j];
	      Numbers[j]=oppNumber;
	      opp=temp;
	      oppNumber=tempNumber;
	    }
      }
  
  
  //and sort them 
  for (i=0;i<5;i++)
    for (j=i+1;j<5;j++)
      if (Opponents[i].getY()>Opponents[j].getY())
	{
	  temp=Opponents[j];
	  tempNumber=Numbers[j];
	  Opponents[j]=Opponents[i];
	  Numbers[j]=Numbers[i];
	  Opponents[i]=temp;
	  Numbers[i]=tempNumber;
	}


  const int OppArray[5]={0,2,4,1,3};
  oppNumber=Numbers[OppArray[me.number-2]];

  if (oppNumber!=UNKNOWN)
    lookObject=&wS->otherTeam(oppNumber);

#ifdef COVERTRACE
  {
    ostrstream tmp;
    tmp << "coverOpp-> 5 Opponents to cover: " ;
    for (i=0; i<5;i++)
      tmp << Numbers[i] <<" ";
    tmp << ", I will cover Opponent: "<< oppNumber<< char(0);
    COVERTRC(MLog(tmp.str()));
  };
#endif
  
  Grade goalShotGrade[5];
  
  //evaluate positions of opponents
  for (i=0;i<5;i++) 
    goalShotGrade[i]=goalShotEval->otherEval(wS,Opponents[i]);
#ifdef COVERTRACE
  {
    ostrstream tmp;
    tmp << "coverOpp-> goalshotgrades: " ;
    for (i=0; i<5;i++)
      tmp << goalShotGrade[i] <<" ";
    tmp << char(0);
    COVERTRC(MLog(tmp.str()));
  };
#endif
    
  if (oppNumber!=UNKNOWN)
    {
      opp=wS->otherTeam(oppNumber).pos;
      if (opp.getX()<-FIELD_LENGTH/2.+PENALTY_AREA_LENGTH+3)
	{
	  COVERTRC(MLog("coverOpp-> cover opponent"));
	  stdact();
	}
      else stdact();
    }
  else stdact();
};

Vector2d PositionModule::CalCoverPos(int CoveredOpp)
  //function serves the "best" position to cover a opponent to not get the ball; 
  //if no position is found or positioin is too far to reach the function serves (0,0).   
{ 
  const double RespectRange = 10;
  //the range our player should always have to the covered opponent player
  const double MaxChangeDist = 10;
  //the limit range our player may move to a covering line 
  Vector2d CoverVektor = wS->otherTeam(CoveredOpp).pos - wS->otherTeam(tS->firstDangerousOpponent).pos;
  //vektor (opponent to cover)-(oponnent with ball) 
  Vector2d myPos = me.pos;
  double OppFactor; //factor that's needed for the CoverVektor
  double MeFactor;  //factor that's needed for the CutVektor
  if (CoverVektor.getY()==0)
    //the covering Line is parallel to our CutVector
    {
      return Vector2d(0,0);
    }
  else
    {
      OppFactor = (myPos.getY()-wS->otherTeam(tS->firstDangerousOpponent).pos.getY())/CoverVektor.getY();
      MeFactor = OppFactor*CoverVektor.getX()-wS->otherTeam(tS->firstDangerousOpponent).pos.getX()+myPos.getX();
      if ((norm(CoverVektor)-RespectRange)>=OppFactor)//do we have the right distance?
        { 
          if ((MeFactor+myPos.getX())<=MaxChangeDist)
            {
              return Vector2d(MeFactor+myPos.getX(),myPos.getY());
            }
          else
            {
              return Vector2d(0,0);
            }
        }
      else //not the right distance
        {
          if ((myPos.getX()*(1-RespectRange)+RespectRange*wS->otherTeam(CoveredOpp).pos.getX())<=MaxChangeDist)
            {
              return Vector2d(myPos.getX()*(1-RespectRange)+RespectRange*wS->otherTeam(CoveredOpp).pos.getX(),myPos.getY()*(1-RespectRange)+RespectRange*wS->otherTeam(CoveredOpp).pos.getY());
            }
          else
            {
              return Vector2d(0,0);
	    }
        }
    } 
};

void PositionModule::SupportPlayer()
{
  Vector2d suppPos=positionEval->GetPlayerPosition(SupportPlayerNo);

  if (wS->ourTeam(SupportPlayerNo).age<5) 
    {
      Vector2d realPos=wS->ourTeam(SupportPlayerNo).pos;
      double howfar=
	1-Step(3,dist(suppPos,positionEval->GetPlayerPosition(me.number)),
	       dist(suppPos,realPos));
      
#ifdef SUPPTRACE
      ostrstream tmp;
      tmp << "Supp. Player-> howfar= " << howfar << char(0);
      SUPPTRC(MLog(tmp.str()));
#endif

      realPos=suppPos-positionEval->GetPlayerPosition(me.number);
      posGoal+=2/3.*howfar*realPos;
      SUPPTRC(LINE(posGoal,me.pos));
      SUPPTRC(LINE(suppPos,positionEval->GetPlayerPosition(me.number)));
      SUPPTRC(POSITION(posGoal));
      SUPPTRC(CIRCLE(suppPos,3));
      SUPPTRC(CIRCLE(posGoal,3));
      SUPPTRC(CIRCLE(positionEval->GetPlayerPosition(me.number),3));
    }
  else
    {
      SUPPTRC(MLog("supp-> resp. player age too old"));
    }
};





