//-*- c++ -*-/////////////////////////////////////////////////////////// 
//
//   $Id: main.C,v 1.3 2001/02/08 21:16:01 goetz Exp $
//
////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>
#include <strings.h>
#include "constants.h"
#include "trainer.h"

int main (int argc, char** argv) {
  char   *team_name= "MRB";
  playing_side side = SIDE_LEFT;
  char   *host= new char [strlen(DEFAULT_HOST)+1];
  strcpy (host, DEFAULT_HOST);
  int    port = COACH_PORT;
  bool   logging = false;
  char   *configfile= "agent.conf";
  
  char   c;
  while((c = getopt( argc, argv, "h:lp:t:f:" ) ) != EOF ) {
    switch(c) {
    case 'h':
      delete (host);
      host = optarg;
      break;
    case 'l':
      logging = true;
      break;
    case 'p':
      port = atoi(optarg);
      break;
    case 't':
      team_name = optarg;
      break;
    case 's':
      side = SIDE_RIGHT;
      break;
    case 'f':
      configfile= optarg;
      break;
    case '?':	// Fehler beim parsen bzw. help-Option
    cerr << "Usage: " << argv[0] << "[-h HOSTNAME]"
      " [-l] [-p PORT] [-t TEAMNAME] [-s]" 
      "[-f FILENAME]" << endl
	 << "  -h HOSTNAME  connects to HOSTNAME" << endl
	 << "  -l           enable server message logging (to \"snaps*.log\")" << endl
	 << "  -p PORT      port number" << endl
	 << "  -t TEAMNAME  sets the coaches team name" << endl
	 << "  -s           sets the coach to the right side (default: left)" << endl

	 << "  -f FILENAME  alternative configuration file for tactics (default agent.conf)" << endl;
    exit(1);
    }
  }

  Trainer *a = new Trainer(team_name, side, host, logging);
  a->coach();
  
  delete (a);
}


